// grades -- compute weighted average for homework grades
//   written using the Data-Parallel Programming Library for Education (DAPPLE)
//
// This program demonstrates some very simple DAPPLE features.  A set
// of students' grades are represented as vectors, and then the 
// program computes the weighted averages.
//
// David Kotz 1995

// $Id: grades.cc,v 1.5 95/12/17 00:08:21 dfk release Locker: dfk $

#include <stdlib.h>
#include <iostream.h>
#include "dapple.h"

const int N = 5;		// number of students, presumably large

int
main()
{
    // homework grades, each for N students
    floatVector hw1(N), hw2(N), hw3(N);
    // weighted average grade
    floatVector average(N);
    // relative weights of the homeworks (should add to 1)
    const float w1 = 0.40, w2 = 0.25, w3 = 0.35;

    cout << "Enter " << N << " HW1 grades: ";
    cin >> hw1;

    cout << "Enter " << N << " HW2 grades: ";
    cin >> hw2;

    cout << "Enter " << N << " HW3 grades: ";
    cin >> hw3;

    cout << endl;
    cout << "HW1 (" << w1*100 << "%): " << hw1 << endl;
    cout << "HW2 (" << w2*100 << "%): " << hw2 << endl;
    cout << "HW3 (" << w3*100 << "%): " << hw3 << endl;

    average = (hw1 * w1) + (hw2 * w2) + (hw3 * w3);

    cout << "Averages: " << average << endl;
    cout << "Best is " << max_value(average) << endl;
    cout << "Worst is " << min_value(average) << endl;

    return(0);
}
