// @TITLE "errors.h: error handling"
//
// This include file defines some macros for error handling.
// Basically, they check a condition; if false, they print an error message and die.
//
// David Kotz 1994

// $Id: errors.h,v 1.11 95/12/17 00:07:47 dfk release Locker: dfk $

#ifndef ERROR_H
#define ERROR_H

#include <stdlib.h>
#include <stdio.h>

#define INVARIANT2(condition, string) \
    if (!(condition)) { \
      fflush(stdout); \
      fprintf(stderr, "\n*** ERROR: "); \
      fprintf(stderr, (string)); \
      fprintf(stderr, "\n"); \
      fflush(stderr); \
      abort(); \
}

#define INVARIANT3(condition, string, a1) \
    if (!(condition)) { \
      fflush(stdout); \
      fprintf(stderr, "\n*** ERROR: "); \
      fprintf(stderr, (string), (a1)); \
      fprintf(stderr, "\n"); \
      fflush(stderr); \
      abort(); \
}

#define INVARIANT4(condition, string, a1, a2) \
    if (!(condition)) { \
      fflush(stdout); \
      fprintf(stderr, "\n*** ERROR: "); \
      fprintf(stderr, (string), (a1), (a2)); \
      fprintf(stderr, "\n"); \
      fflush(stderr); \
      abort(); \
}

#endif //  ERROR_H
